# 发展历程

## 1. 从商业闭源走向社区开源

OpenMLDB 起源于业界领先的人工智能平台和服务提供商[第四范式](https://www.4paradigm.com)的内部商业产品。第四范式所提供的商业化人工智能平台，覆盖机器学习端到端应用开发和落地的全流程，包括数据治理、特征工程、模型训练和推理、模型管理等各个方面。其产品在上百个企业级场景中得到部署和大规模应用。

2021 年，OpenMLDB 的核心开发团队将第四范式闭源商业产品中的数据治理和特征工程的核心模块进行了抽象、增强、以及添加了诸多社区友好化特性，进行了二次开发，发布形成了今天的开源项目  OpenMLDB。OpenMLDB 脱胎于经过长达五年实践检验的商业化产品，并且在该领域具有大量的经验沉淀和独特理解。今天，OpenMLDB 立足于开源开放的社区进行发展，期望帮助更多的企业低成本高质量完成人工智能转型。

## 2. Milestones

### 2017.2 - 2021.5: 闭源 MLDB

- 2017.2：第一次代码 commit
- 2017.9：第一个金融行业客户，广发银行
- 2019.8：第一个零售行业用户，百胜集团
- 2020.12：落地场景累计超过 100 个

### 2021.6 - 今天：开源 OpenMLDB

- 2021.6：机器学习数据库 OpenMLDB 正式宣布开源，提供企业级 FeatureOps 全栈解决方案
- 2021.7：v0.2.0发布，支持 RestAPI 访问，优化代码风格和注释
- 2021.8：基于 OpenMLDB 的优化创新论文在国际顶级数据库学术会议 VLDB 2021 发表
- 2021.8：获得 Gitee 认可，荣获GVP（ Gitee Most Valuable Project，即最有价值开源项目）称号
- 2021.9：第一个开源社区企业用户，[Akulaku](https://www.akulaku.com/)
- 2021.9：荣获信通院“开源社区及开源项目”奖项
- 2021.11：v0.3.0 发布，支持快速部署使用的单机部署模式
- 2021.12：OpenMLDB 贡献者计划启动
- 2021.12：举办国内首次 Feature Store Meetup
- 2022.1：v0.4.0 发布，增强 SQL 为核心的开发体验，引入在线监控模块
- 2022.1：OpenMLDB 第一次社区会议
- 2022.5: v0.5.0 发布，支持长窗口预聚合、持久化存储引擎和动态注册udf函数等特性

## 3. 发展计划

OpenMLDB 未来的发展将会坚定地走社区化开源开放的路线，以期望让更多企业和开发者收益。未来，在技术方向上我们会更为关注有效降低使用门槛和成本的技术，如云原生技术；在社区建设上，我们将加快生态建设，完善产品信息，扩展工业和学术界的合作；最后，期望更多的开发者和用户能够参与到我们的社区中来，共同推进 OpenMLDB 社区的快速成长。
